#define COMMAND_MAX 30000

enum { Load, ReSetEngine, Show, Hide, InfoDimension, StartData, EndData, Data, 
Scale, SetObject, Left, Right, Up, Down, In, Out, Taller, Shorter, Bigger, 
Smaller, SetMax, SetValue, Cycle, Fatter, Thinner, FadeOut, FadeIn, Inline, Debug, Label,
StartTemplate, EndTemplate, TemplateData };

class Command {
public:
	Command( int command, char* p1, char* p2 );
	~Command();
	int getValue() { return( command ); }
	char* getParam() { return( param1 ); }
	char* getParam2() { return( param2 ); }
	char* takeParam() { char* result = param1; param1 = (char*)0; return result; }
private:
	int command;
	char* param1;
	char* param2;
};

class CommandQueue {
public:
	CommandQueue();
	void queue( char* command );
	Command* getNextCommand();
	Command* unconditionalGetNextCommand();
	void load( char* filename );
	void debugOn() { debug = true; }
	void addCommand( int command, char* p );
private:
	char* toStr( int command );
	bool debug;
	bool inData;
	bool inTemplate;
	int incValue( int v );
	bool spaceAvailable();
	bool hasCommand();
	int currentIdx;  // next place to put a command
	int nextCommandIdx; // next command to execute
	int command[COMMAND_MAX];
	char* param1[COMMAND_MAX];
	char* param2[COMMAND_MAX];
};


